#property indicator_chart_window

#property indicator_buffers 2

#property indicator_color1 Red
#property indicator_color2 Aqua

#property indicator_width1 2
#property indicator_width2 2


double Buffer.AboveMA[];
double Buffer.BelowMA[];
double Buffer.MA[];

extern int MA.Method = MODE_EMA;
extern int MA.Period = 20;
extern int MA.Shift = 0;
extern int MA.Price = PRICE_CLOSE;
extern bool			UseAlert			= false;

double alertTag;
static bool buy= false;
static bool sell=false;
int init() 
{
  IndicatorBuffers(3);

  IndicatorShortName("Colored MA");
  
  SetIndexBuffer(0, Buffer.AboveMA);
  SetIndexStyle(0, DRAW_LINE);
  SetIndexShift(0, MA.Shift);   
  SetIndexLabel(0, "MA_Up");
  
  
  
  SetIndexBuffer(1, Buffer.BelowMA);
  SetIndexStyle(1, DRAW_LINE);
  SetIndexShift(1, MA.Shift);   
  SetIndexLabel(1, "MA_Down");
  
  
  SetIndexBuffer(2, Buffer.MA);
  
  return (0);
}

int start() 
{
   for (int i = 0; i <=Bars-10; i++) 
      Buffer.MA[i] = iMA(NULL, 0, MA.Period, 0, MA.Method, MA.Price, i);
      

   for (i = 0; i <=Bars-10; i++) 
   {
      Buffer.AboveMA[i] = Buffer.MA[i];
      Buffer.BelowMA[i] = Buffer.MA[i];
      if (Buffer.MA[i] > Buffer.MA[i + 1] && Buffer.MA[i + 1] > Buffer.MA[i + 2]) 
      {
         Buffer.AboveMA[i] = EMPTY_VALUE;
         Buffer.AboveMA[i + 1] = EMPTY_VALUE;
         Buffer.BelowMA[i + 1] = Buffer.MA[i + 1];
         if (!buy)
         {
         DoAlert(Symbol()+"BUY" + NormalizeDouble(Ask,4));
         buy =true;
         }
         
      } 

      else 
      {
         if (Buffer.MA[i] < Buffer.MA[i + 1] && Buffer.MA[i + 1] < Buffer.MA[i + 2]) 
         {
            Buffer.BelowMA[i] = EMPTY_VALUE;
            Buffer.BelowMA[i + 1] = EMPTY_VALUE;
            Buffer.AboveMA[i + 1] = Buffer.MA[i + 1];
                       
         }
          if (!sell)
         {
         DoAlert(Symbol()+"SELL" + NormalizeDouble(Ask,4));
         sell =true;
         }
         
      }
   }
   return (0);
}

void DoAlert( string str)
{
	if (UseAlert&&alertTag!=Time[0] )

		Alert(str);
	
	alertTag = Time[0];
}